import greenfoot.*;

/**
 * Write a description of class StarshipWorld here. 
 * 
 * @author (Roy Smith & Nolan Sherman) 
 * @version (V1.2)
 */
public class StarshipWorld extends World
{
    public int locationX;
    public int locationY;
    public int randomSpawn;
    private int xOffset = 0;
    
    /**
     * Constructor for objects of class Starship.
     */
    public StarshipWorld()
    {    
        // Create a new world with 600x400 cells with a cell size of 1x1 pixels.
        super(800, 800, 1);
        //change the paint order
        setPaintOrder(PlayerLife.class, GameOver.class, Enemy.class, Explosion.class, Projectile.class, Player.class, Portal.class);
        
        //Methods to prepare the World
        prepareWorld();
    }
    
    public void act()
    {
        //
    }
    
    /**
     * Initiate the World with the following parameters
     */
    public void prepareWorld()
    {
        int startLives = 5;
        spawnPlayer();
        for(int i = 0; i < startLives; i++)
        {
            PlayerLife life = new PlayerLife();
            addObject(life, 360 + xOffset, 20);
            xOffset = xOffset + 20;
        }
        
        Portal portal0 = new Portal();
        addObject(portal0, 400, 380);
        
        //determine how many enemies will populate the screen
        randomSpawn = (Greenfoot.getRandomNumber(4)+3);
        
        //this loop is used to spawn enemies to the world based on the # randomSpawn generates
        for(int i = 0; i < randomSpawn; i++)
        {
            spawnEnemy();
        }
    }
    
    /**
     * this method creates (4) 200x200 fields for the enemies to be placed in when they spawn. in turn this creates a 400x800
     * (T) shaped safe zone for the Player to spawn in.
     */
    public void spawnEnemy()
    {
        boolean isPlaced = false;
        int locationX = 400;
        int locationY = 400;
            //by starting the locationX & locationY with a value of 400, it starts the while loops
            locationX = Greenfoot.getRandomNumber(800);
            locationY = Greenfoot.getRandomNumber(800);
        
            //if the X location is between 200 & 600 generate a new number, if the number is below 200 and above 600 keep the number
            //and pass the location to the enemy
            while (locationX < 50 && locationX > 750)
            {
                locationX = Greenfoot.getRandomNumber(800);
            }
            //if the Y location is between 200 & 600 generate a new number, if the number is below 200 and above 600 keep the number
            //and pass the location to the enemy
            while (locationY > 200 && locationY < 600)
            {
                locationY = Greenfoot.getRandomNumber(800);
            }
        
        Enemy enemy0 = new Enemy();
        addObject(enemy0, locationX, locationY);
        
    }
    
    private void spawnPlayer()
    {
        Player player0 = new Player();
        addObject(player0, 400, 400);    
    }
}
